Attribute VB_Name = "modDescription"
Option Explicit
' Original module by Puskai Zoltan at PlanetSourceCode
' http://www.planetsourcecode.com/vb/scripts/ShowCode.asp?txtCodeId=6608&lngWId=1

Public Const M_SOF0 = &HC0
Public Const M_SOF1 = &HC1
Public Const M_SOF2 = &HC2
Public Const M_SOF3 = &HC3
Public Const M_SOF5 = &HC5
Public Const M_SOF6 = &HC6
Public Const M_SOF7 = &HC7
Public Const M_SOF9 = &HC9
Public Const M_SOF10 = &HCA
Public Const M_SOF11 = &HCB
Public Const M_SOF13 = &HCD
Public Const M_SOF14 = &HCE
Public Const M_SOF15 = &HCF
Public Const M_SOI = &HD8
Public Const M_EOI = &HD9
Public Const M_SOS = &HDA
Public Const M_COM = &HFE
'Public Const MAX_COM_LENGTH = 65000
Private fileNr As Integer
Private fileNrDest As Integer

Private Function NEXTBYTE() As Byte
Dim c As Byte
If EOF(fileNr) Then
    Exit Function
End If
Get #fileNr, , c
NEXTBYTE = c
End Function

Private Sub PUTBYTE(c As Byte)
Put #fileNrDest, , c
End Sub

Private Function read_1_byte() As Byte
Dim c As Byte
If EOF(fileNr) Then
    Exit Function
End If
Get #fileNr, , c
read_1_byte = c

End Function

Private Function read_2_byte() As Double
Dim c1 As Byte
Dim c2 As Byte
If EOF(fileNr) Then
    Exit Function
End If
Get #fileNr, , c1
If EOF(fileNr) Then
    Exit Function
End If
Get #fileNr, , c2
read_2_byte = CDbl(c1) * CDbl(256) + c2
End Function

Private Function next_marker() As Byte
Dim c As Byte
Dim discarded_bytes As Integer
c = read_1_byte
While c <> &HFF
    discarded_bytes = discarded_bytes + 1
    c = read_1_byte
Wend
Do
    c = read_1_byte
Loop While c = &HFF
'If discarded_bytes <> 0 Then MsgBox "Warning: garbage data found in JPEG file"
next_marker = c
End Function

Private Function first_marker() As Byte
Dim c1 As Byte, c2 As Byte
c1 = NEXTBYTE
c2 = NEXTBYTE
If c1 <> &HFF And c2 <> M_SOI Then MsgBox "not a JPEG file"
first_marker = c2
End Function
Private Sub skip_variable()
Dim Length As Double
Length = read_2_byte
If Length < 2 Then MsgBox "Erroneous JPEG marker length"
Length = Length - 2
While Length > 0
    read_1_byte
    Length = Length - 1
Wend
End Sub

Private Function process_COM() As String
Dim Length  As Double
Dim ch As Byte
Dim s As String
'lastch = 0
Length = read_2_byte
If Length < 2 Then MsgBox "Erroneous JPEG marker length"
Length = Length - 2
While Length > 0
    ch = read_1_byte
    s = s & Chr$(ch)
    Length = Length - 1
Wend
process_COM = s
End Function
Private Sub write_1_byte(c As Byte)
     PUTBYTE c
End Sub

Private Sub write_2_byte(c As Double)
    PUTBYTE ((c / 256) And &HFF)
    PUTBYTE (c And &HFF)
End Sub

Private Sub write_marker(marker As Byte)
    PUTBYTE &HFF
    PUTBYTE marker
End Sub
Private Sub copy_variable()
Dim Length As Double
Length = read_2_byte
write_2_byte Length
Length = Length - 2
While (Length > 0)
    write_1_byte read_1_byte
Length = Length - 1
Wend

End Sub
Public Function scan_JPEG_header(strFileName As String) As String

Dim marker As Integer
Dim returnedString As String

fileNr = FreeFile
Open strFileName For Binary Access Read As #fileNr

If first_marker <> M_SOI Then
    MsgBox "Expected SOI marker first"
    Exit Function
End If
Do
    marker = next_marker
    Select Case marker
        Case M_SOS:         ' stop before hitting compressed data
            If returnedString <> "" Then
                scan_JPEG_header = Left$(returnedString, Len(returnedString) - 1)
            Else
                scan_JPEG_header = returnedString
            End If

            Close #fileNr
            Exit Function
        Case M_EOI:         ' in case it's a tables-only JPEG stream
            scan_JPEG_header = returnedString
            Close #fileNr
            Exit Function
        Case M_COM:
            returnedString = returnedString & process_COM & vbTab
        Case Else:            ' Anything else just gets skipped
            skip_variable ' we assume it has a parameter count...
        End Select
Loop
Close #fileNr
End Function
Public Sub WriteJPGComment(Filename As String, Comment As String)
Dim notyet As Boolean
Dim fileNametemp As String
Dim a As Byte, s1 As Byte, s2 As Byte, l1 As Byte, l2 As Byte, T As Byte, x As Byte
Dim I As Long
Dim sComment As String
Dim fileNr As Integer
Dim fileNrTemp As Integer
Dim FilePos As Double
Dim FilePosTemp As Double
Dim MySize As Double
Dim N As Integer
'added
Dim b As String

fileNametemp = Filename & "temp.jpg"
'On Error Resume Next
If Dir(fileNametemp) <> "" Then
    Kill fileNametemp
End If
notyet = True
fileNr = FreeFile
Open Filename For Binary As #fileNr
fileNrTemp = FreeFile
Open fileNametemp For Binary Access Write As #fileNrTemp


Get #fileNr, , a
Put #fileNrTemp, , a
Get #fileNr, , a
Put #fileNrTemp, , a
Do
    Get #fileNr, , T
    Put #fileNrTemp, , T
    While T <> &HFF
        Get #fileNr, , T
        Put #fileNrTemp, , T
    Wend
    s1 = &HFF
    Get #fileNr, , s2
        While s2 = &HFF
            Get #fileNr, , s2
        Wend
    Get #fileNr, , l1
    Get #fileNr, , l2
    sComment = ""
    For I = 1 To (CDbl(256) * CDbl(l1) + l2) - 2
        If Not EOF(fileNr) Then
                Get #fileNr, , x
                sComment = sComment & Chr$(x)
        End If
    Next
    If ((s2 And &HF0) = &HC0) And notyet And (Comment <> "") Then
        a = &HFF
        Put #fileNrTemp, , a
        a = &HFE
        Put #fileNrTemp, , a
        a = CByte((Len(Comment) + 2) / 256)
        Put #fileNrTemp, , a
        a = CByte((Len(Comment) + 2) Mod 256)
        Put #fileNrTemp, , a
        For I = 1 To Len(Comment)
            a = CByte(Asc(Mid$(Comment, I, 1)))
            Put #fileNrTemp, , a
        Next
        notyet = False
    End If
    If s2 <> &HFE Then
        Put #fileNrTemp, , s1
        Put #fileNrTemp, , s2
        Put #fileNrTemp, , l1
        Put #fileNrTemp, , l2
        For I = 1 To Len(sComment)
            a = CByte(Asc(Mid$(sComment, I, 1)))
            Put #fileNrTemp, , a
        Next
        
    End If
Loop Until EOF(fileNr) Or s2 = &HDA

FilePos = Seek(fileNr)
FilePosTemp = Seek(fileNrTemp)
'MySize = LOF(fileNr) - FilePos
MySize = LOF(fileNr) - FilePos + 1

ReDim arr(MySize)
Close #fileNr
Close #fileNrTemp
fileNr = FreeFile
Open Filename For Binary As #fileNr
fileNrTemp = FreeFile
Open fileNametemp For Binary As #fileNrTemp
Seek #fileNr, FilePos
Seek #fileNrTemp, FilePosTemp
N = Int(MySize / 4096)
If N Then
    For I = 1 To N
        b$ = Space$(4096)
        Get #fileNr, , b$
        Put #fileNrTemp, , b$
    Next
End If
N = MySize Mod 4096
If N Then
    b$ = Space$(N)
    Get #fileNr, , b$
    Put #fileNrTemp, , b$
End If
Close #fileNr
Close #fileNrTemp
Kill Filename
Name fileNametemp As Filename
End Sub


